Index: trunk/LMDZ.TITAN/libf/chimtitan/solve.c
===================================================================
--- trunk/LMDZ.TITAN/libf/chimtitan/solve.c	(revision 1121)
+++ trunk/LMDZ.TITAN/libf/chimtitan/solve.c	(revision 1126)
@@ -2,20 +2,22 @@
 /* cf Numerical Recipes LU Method for equations numbers */
 /* GCCM */
-/* une seule cellule concernee */
+/* similaire a inv (GP) */
 /* la matrice a est inversee seulement sur le bloc [n0;n1][n0;n1] */
-/* la matrice f ressort les dy */
 
 #include "titan.h"
 
-void solve( double **a, double *f, int n0, int n1 )
+void solve( double ***aa, int m, int n0, int n1 )
 {
-   int    i,ii,imax,k,l,ll;
-   double aamax,dum,*indx,sum,*vv,tmp;
+   int    i,ii,imax,j,k,l,ll;
+   double **a,aamax,dum,*indx,sum,**vv,tmp;
    FILE   *out;
 
    indx = dm1d( n0, n1 );
-   vv   = dm1d( n0, n1 );
+   vv   = dm2d( n0, n1, n0, n1 );
+   a    = dm2d( n0, n1, n0, n1 );
    imax = n0;
 
+   for( i = n0; i <= n1; i++ ) for( j = n0; j <= n1; j++ ) a[i][j]=aa[m][i][j];
+   
    for( i = n0; i <= n1; i++ )
    {
@@ -32,5 +34,5 @@
 /*         aamax = 1.e-30; */
       }
-      vv[i] = 1.0e0 / aamax;   /* Save the scaling */
+      vv[i][1] = 1.0e0 / aamax;   /* Save the scaling */
 /*
       if( (aamax > 1.0e100)||(aamax < 1.0e-100) )
@@ -59,5 +61,5 @@
             sum -= ( a[i][l] * a[l][k] );
          a[i][k] = sum;
-         dum        = vv[i] * fabs(sum);   /* Figure of merit for the pivot */
+         dum        = vv[i][1] * fabs(sum); /* Figure of merit for the pivot */
          if( dum >= aamax )          /* Is it better than the best so far ? */
          {
@@ -74,5 +76,5 @@
             a[k][l]    = dum;
          }
-         vv[imax] = vv[k];    /* Also interchange the scale factor */
+         vv[imax][1] = vv[k][1];    /* Also interchange the scale factor */
       }
       indx[k] = imax;
@@ -94,26 +96,41 @@
    }                                  /* Go back to the next column in the reduction */
 
+   for( i = n0; i <= n1; i++ )
+   {
+      for( k = n0; k <= n1; k++ )
+         vv[i][k] = 0.0e0;
+      vv[i][i] = 1.0e0;
+   }
+
+   for( l = n0; l <= n1; l++ )
+   {
       ii = n0-1;
       for( i = n0; i <= n1; i++ )
       {
          ll    = indx[i];
-         sum   = f[ll];
-         f[ll] = f[i];
+         sum   = vv[ll][l];
+         vv[ll][l] = vv[i][l];
          if( ii != (n0-1) )
             for( k = ii; k < i; k++ )
-               sum -= ( a[i][k] * f[k] );
+               sum -= ( a[i][k] * vv[k][l] );
          else if( sum != 0.0e0 ) ii = i;
-         f[i] = sum;
+         vv[i][l] = sum;
       }
       for( i = n1; i >= n0; i-- )
       {
-         sum = f[i];
+         sum = vv[i][l];
          if( i < n1 )
             for( k = i+1; k <= n1; k++ )
-               sum -= ( a[i][k] * f[k] );
-         f[i] = sum / a[i][i];
+               sum -= ( a[i][k] * vv[k][l] );
+         vv[i][l] = sum / a[i][i];
       }
+   }
          
+   for( i = n0; i <= n1; i++ ) 
+     for( l = n0; l <= n1; l++ ) 
+       aa[m][i][l]=vv[i][l];
+
    fdm1d( indx, n0 );
-   fdm1d(   vv, n0 );
+   fdm2d(   vv, n0, n1, n0 );
+   fdm2d(    a, n0, n1, n0 );
 }
Index: trunk/LMDZ.TITAN/libf/chimtitan/solve_b.c
===================================================================
--- trunk/LMDZ.TITAN/libf/chimtitan/solve_b.c	(revision 1126)
+++ trunk/LMDZ.TITAN/libf/chimtitan/solve_b.c	(revision 1126)
@@ -0,0 +1,126 @@
+/* matrix inversion */
+/* cf Numerical Recipes LU Method for equations numbers */
+/* GCCM */
+/* similaire a inv (GP) */
+/* la matrice a est inversee seulement sur le bloc [n0;n1][n0;n1] */
+
+#include "titan.h"
+
+void solve_b( double ***aa, double **f, int m, int n0, int n1 )
+{
+   int    i,ii,imax,j,k,l,ll;
+   double **a,aamax,dum,*indx,sum,*vv,tmp;
+   FILE   *out;
+
+   indx = dm1d( n0, n1 );
+   vv   = dm1d( n0, n1 );
+   a    = dm2d( n0, n1, n0, n1 );
+   imax = n0;
+
+   for( i = n0; i <= n1; i++ ) for( j = n0; j <= n1; j++ ) a[i][j]=aa[m][i][j];
+   
+   for( i = n0; i <= n1; i++ )
+   {
+      aamax = 0.0e0;
+      for( k = n0; k <= n1; k++ )
+         if( (tmp=fabs(a[i][k])) > aamax ) aamax = tmp;
+      if( aamax < 1.0e-20 )
+      {
+         out = fopen( "err.log", "a" );
+         fprintf( out, "Singular matrix. n0=%ld k=%ld aamax=%le\n",
+                        n0,k,aamax);
+         fclose( out );
+         exit(0);   
+/*         aamax = 1.e-30; */
+      }
+      vv[i] = 1.0e0 / aamax;   /* Save the scaling */
+/*
+      if( (aamax > 1.0e100)||(aamax < 1.0e-100) )
+      {
+         out = fopen( "err.log", "a" );
+         fprintf( out, "ATTENTION aamax = %le\n", aamax );
+         fclose( out );
+         exit( 0 );
+      }
+*/
+   }
+   for( k = n0; k <= n1; k++ )
+   {
+      for( i = n0; i < k; i++ )      /* This is equation 2.3.12 except for i = j */
+      {
+         sum = a[i][k];
+         for( l = n0; l < i; l++ )
+            sum -= ( a[i][l] * a[l][k] );
+         a[i][k] = sum;
+      }
+      aamax = 0.0e0;                 /* Initialize for the search for largest pivot element */
+      for( i = k; i <= n1; i++ )     /* This is i = j of equation 2.3.12 and */
+      {
+         sum = a[i][k];              /* i = J + 1,...,N of equation 2.3.13 */
+         for( l = n0; l < k; l++ )
+            sum -= ( a[i][l] * a[l][k] );
+         a[i][k] = sum;
+         dum        = vv[i] * fabs(sum); /* Figure of merit for the pivot */
+         if( dum >= aamax )          /* Is it better than the best so far ? */
+         {
+            imax  = i;
+            aamax = dum;
+         }
+      }
+      if( k != imax )                /* Do we need to interchange rows ? */
+      {
+         for( l = n0; l <= n1; l++ ) /* Yes, do so... */
+         {
+            dum        = a[imax][l];
+            a[imax][l] = a[k][l];
+            a[k][l]    = dum;
+         }
+         vv[imax] = vv[k];    /* Also interchange the scale factor */
+      }
+      indx[k] = imax;
+      if( fabs(a[k][k]) < 1.0e-20 )
+      {
+         out = fopen( "err.log", "a" );
+         fprintf( out, "Pivot too small. n0=%ld k=%ld fabs(a[k][k])=%le\n",
+                        n0,k,fabs(a[k][k]) );
+         fclose( out );
+         exit(0);   
+/*         a[k][k] = 1.e-20; */
+      }
+      if( k != n1 )                   /* If the pivot element is less than 1.0d-20 we */
+      {                               /* assume that the matrix is singular */
+          dum = a[k][k];              /* ( at least to the precision of the algorithm and the machine ) */
+         for( i = k+1; i <= n1; i++ ) /* Now, finally devide by the pivot element */
+            a[i][k] /= dum;
+      }
+   }                                  /* Go back to the next column in the reduction */
+
+   for( i = n0; i <= n1; i++ ) vv[i]=f[i][m];
+
+      ii = n0-1;
+      for( i = n0; i <= n1; i++ )
+      {
+         ll    = indx[i];
+         sum   = vv[ll];
+         vv[ll] = vv[i];
+         if( ii != (n0-1) )
+            for( k = ii; k < i; k++ )
+               sum -= ( a[i][k] * vv[k] );
+         else if( sum != 0.0e0 ) ii = i;
+         vv[i] = sum;
+      }
+      for( i = n1; i >= n0; i-- )
+      {
+         sum = vv[i];
+         if( i < n1 )
+            for( k = i+1; k <= n1; k++ )
+               sum -= ( a[i][k] * vv[k] );
+         vv[i] = sum / a[i][i];
+      }
+         
+   for( i = n0; i <= n1; i++ ) f[i][m]=vv[i];
+
+   fdm1d( indx, n0 );
+   fdm1d(   vv, n0 );
+   fdm2d(    a, n0, n1, n0 );
+}
Index: trunk/LMDZ.TITAN/libf/chimtitan/titan.h
===================================================================
--- trunk/LMDZ.TITAN/libf/chimtitan/titan.h	(revision 1121)
+++ trunk/LMDZ.TITAN/libf/chimtitan/titan.h	(revision 1126)
@@ -7,11 +7,18 @@
 
 #define R0    (double)(2575.0) /* Titan's radius */
-#define NLEV  (int)(55)   /* Nbre de niv verticaux - aussi dans titan_for.h */
+#define NLEV  (int)(125)  /* Nbre de niv verticaux - =llm+70 dans common_mod */
+#define NLD   (int)(40)   /* Nbre de niv verticaux faits sans diff */
+#define NLRT  (int)(650)  /* Nbre de niv verticaux dans table fmoy - aussi dans common_mod */
+
+/* fluxes at 1300 km : upward is +, downward is - */
+#define top_H   (double)(+1.1e4)
+#define top_H2  (double)(+3.7e3)
+#define top_N4S (double)(-1.1e8) /* = -2.5e8/2.27 ... */
 
 /* DEPEND DE LA VERSION CHIMIE: */
 #define VERCHIM "chimie_simpnit_051006_bis"
-#define NREAC (int)(377)    /* nombre de reactions - aussi dans titan_for.h */
-#define RDISS (int)(54)     /* nombre de photodiss - aussi dans titan_for.h */
-#define NC    (int)(44)     /* nb de composes      - aussi dans titan_for.h */
+#define NREAC (int)(377)    /* nombre de reactions - aussi dans common_mod */
+#define RDISS (int)(54)     /* nombre de photodiss - aussi dans common_mod */
+#define NC    (int)(44)     /* nb de composes      - aussi dans common_mod */
 #define ST    (int)(NC)     /* nb de composes inverses */
 #define NHC   (int)(32)     /* nb hydrocarbons */
@@ -27,14 +34,11 @@
 #endif
 
-/* void  gptitan_(const int *, float *, float *, float *, float *, float *, 
-      char (*)[10], float (*)[NLEV], float *,
-      float *, float *, float *, int *, float *, 
-      float *, float (*)[NLEV][RDISS+1][15], float (*)[NLEV],
-      int (*)[5], int *, int *, int (*)[200], int (*)[200][2] ); */
 void  chimie_(char (*)[10], double *, double *, double (*)[NLEV], 
               int (*)[5], int *, int *, int (*)[200][2], int (*)[200]);
-void  comp_(char (*)[10], double *);
-void  disso_(double (*)[NLEV][RDISS+1][15], int *);
-void  solve( double **, double *, int, int );
+void  comp_(char (*)[10], double *, double *, double *, double (*)[NLEV]);
+void  disso_(double (*)[NLRT][RDISS+1][15], int *);
+double omega( double, double, double );
+void  solve( double ***, int, int, int );
+void  solve_b( double ***, double **, int, int, int );
 float *rm1d( int, int );
 float **rm2d( int, int, int, int );
Index: trunk/LMDZ.TITAN/libf/phytitan/calchim.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calchim.F	(revision 1121)
+++ trunk/LMDZ.TITAN/libf/phytitan/calchim.F	(revision 1126)
@@ -1,4 +1,4 @@
       SUBROUTINE calchim(nlon,ny,qy_c,nomqy_c,declin_rad,ls_rad,dtchim,
-     .                   ctemp,cplay,cplev,
+     .                   ctemp,cplay,cplev,czlay,czlev,
      .                   dqyc)
       
@@ -10,12 +10,13 @@
 c            adaptation pour Titan 3D: 02/2009
 c            adaptation pour // : 04/2013
-c
+c            extension chimie jusqu a 1300km : 10/2013
+c 
 c-------------------------------------------------
 c
       use dimphy
       use common_mod, only:utilaer,maer,prodaer,csn,csh,psurfhaze,
-     .                     NLEV,NC,ND,NR
+     .                     NLEV,NLRT,NC,ND,NR
       USE comgeomphy,  only: rlatd
-      use moyzon_mod,  only: klat
+      USE moyzon_mod, only: tmoy,playmoy,zlaymoy,zlevmoy,klat
       implicit none
 #include "dimensions.h"
@@ -35,5 +36,7 @@
       REAL         ctemp(nlon,klev)      ! Temperature
       REAL         cplay(nlon,klev)      ! pression (Pa)
-      REAL         cplev(nlon,klev)      ! pression intercouches (Pa)
+      REAL         cplev(nlon,klev+1)    ! pression intercouches (Pa)
+      REAL         czlay(nlon,klev)      ! altitude (m)
+      REAL         czlev(nlon,klev+1)    ! altitude intercouches (m)
       
       REAL         dqyc(nlon,klev,NC)    ! Tendances especes chimiques 
@@ -46,17 +49,19 @@
 c variables envoyees dans la chimie: double precision
 
-      REAL  temp_c(klev),press_c(klev)     ! T,p(mbar) a 1 lat donnee
-      REAL  declin_c                       ! declinaison en degres
-      REAL  cqy(klev,NC)                   ! frac mol qui seront modifiees
-      REAL  surfhaze(klev)
-      REAL  cprodaer(klev,4),cmaer(klev,4),ccsn(klev,4),ccsh(klev,4)
-      REAL  rinter(klev),nb(klev)
+      REAL  temp_c(NLEV)
+      REAL  press_c(NLEV)   ! T,p(mbar) a 1 lat donnee
+      REAL  cqy(NLEV,NC)    ! frac mol qui seront modifiees
+      REAL  cqy0(NLEV,NC)    ! frac mol avant modif
+      REAL  surfhaze(NLEV)
+      REAL  cprodaer(NLEV,4),cmaer(NLEV,4)
+      REAL  ccsn(NLEV,4),ccsh(NLEV,4)
+! rmil: milieu de couche, grille pour K,D,p,ct,T,y
+! rinter: intercouche (grille RA dans la chimie)
+      REAL  rmil(NLEV),rinter(NLEV),nb(NLEV)
+      REAL,save :: kedd(NLEV)
+
       REAL  a,b
       character str1*1,str2*2
-      integer ntotftop
-      parameter (ntotftop=50)
-      integer nftop(ntotftop),isaisonflux
-      REAL  fluxtop(NC),latit,tabletmp(ntotftop),factflux
-      character*10 nomsftop(ntotftop+1)
+      REAL  latit
       character*20 formt1,formt2,formt3
       
@@ -67,14 +72,20 @@
       SAVE    firstcal
       
-      REAL  mass(NC),duree
-      REAL  tablefluxtop(NC,jjp1,5)
-      REAL  botCH4
+      integer dec,declinint,ialt
+      REAL  declin_c                       ! declinaison en degres
+      real  factalt,factdec,krpddec,krpddecp1,krpddecm1
+      real  duree
+      REAL,save :: mass(NC)
+      REAL,save,allocatable :: md(:,:)
+      REAL,save :: botCH4
       DATA  botCH4/0.05/
+      real,save ::  r1d(131),ct1d(131),p1d(131),t1d(131) ! lecture tcp.ver
       REAL,save,allocatable :: krpd(:,:,:,:),krate(:,:)
-      integer reactif(5,NR),nom_prod(NC),nom_perte(NC)
-      integer prod(200,NC),perte(2,200,NC)
-      SAVE    mass,tablefluxtop,botCH4
-      SAVE    reactif,nom_prod,nom_perte,prod,perte
-      
+      integer,save :: reactif(5,NR),nom_prod(NC),nom_perte(NC)
+      integer,save :: prod(200,NC),perte(2,200,NC)
+      character  dummy*30,fich*7,ficdec*15,curdec*15,name*10
+      real  ficalt,oldq,newq,zalt
+      logical okfic
+
 c-----------------------------------------------------------------------
 c***********************************************************************
@@ -94,16 +105,7 @@
 c ************************************
 
-        allocate(krpd(15,ND+1,klev,jjp1),krate(klev,NR))
-
-c Verification dimension verticale: coherence titan_for.h et klev
-c --------------------------------
-
-        if (klev.ne.NLEV) then
-	   print*,'PROBLEME de coherence dans la dimension verticale:'
-     .           ,klev,NLEV
-           STOP
-	endif
-
-c Verification du nombre de composes: coherence titan_for.h et nqmax-nmicro
+        allocate(krpd(15,ND+1,NLRT,jjp1),krate(NLEV,NR),md(NLEV,NC))
+
+c Verification du nombre de composes: coherence common_mod et nqmax-nmicro
 c ----------------------------------
 
@@ -114,114 +116,72 @@
 	endif
 
-c calcul de temp_c, densites et press_c au milieu de l'ensemble des points:
-c ----------------------------------------------------------------------
-
-        print*,'pression, densites et temp (chimie):'
+c calcul de temp_c, densites et press_c en moyenne planetaire :
+c --------------------------------------------------------------
+
+        print*,'pression, densites et temp (init chimie):'
         print*,'level, press_c, nb, temp_c'
         DO l=1,klev
+         rinter(l)  = (zlevmoy(l)+RA)/1000.
+         rmil(l)    = (zlaymoy(l)+RA)/1000.
 c     temp_c (K):
-         temp_c(l)  = ctemp(nlon/2+1,l)
+         temp_c(l)  = tmoy(l)
 c     press_c (mbar):
-         press_c(l) = cplay(nlon/2+1,l)/100.
+         press_c(l) = playmoy(l)/100.
 c     nb (cm-3):
          nb(l) = 1.e-4*press_c(l) / (RKBOL*temp_c(l))
-         print*,l,press_c(l),nb(l),temp_c(l)
+         print*,l,rmil(l)-RA/1000.,press_c(l),nb(l),temp_c(l)
         ENDDO
+
+c au-dessus du GCM, dr regulier et rinter(NLEV)=1290+2575 km.
+       do l=klev+1,NLEV
+         rinter(l) = rinter(klev)
+     &          + (l-klev)*(3865.-rinter(klev))/(NLEV-klev)
+         rmil(l)   = rmil(klev)
+     &          + (l-klev)*(3865.-rinter(klev))/(NLEV-klev)
+       enddo        
+
+c lecture de tcp.ver, une seule fois
+c remplissage r1d,t1d,ct1d,p1d
+        open(11,file='../../INPUT/tcp.ver',status='old')
+        read(11,*) dummy
+        do i=1,131
+          read(11,*) r1d(i),t1d(i),ct1d(i),p1d(i)
+c         print*,"TCP.VER ",r1d(i),t1d(i),ct1d(i),p1d(i)
+        enddo 
+        close(11)
+
+c extension pour klev+1 a NLEV avec tcp.ver
+c la jonction klev/klev+1 est brutale... Tant pis ?
+        ialt=1
+        do l=klev+1,NLEV
+           zalt=rmil(l)-RA/1000.
+           do i=ialt,130
+            if ((zalt.ge.r1d(i)).and.(zalt.lt.r1d(i+1))) then
+              ialt=i
+            endif
+           enddo
+           factalt = (zalt-r1d(ialt))/(r1d(ialt+1)-r1d(ialt))
+           press_c(l) = exp(  log(p1d(ialt))   * (1-factalt) 
+     &                      + log(p1d(ialt+1)) * factalt    )
+           nb(l)      = exp(  log(ct1d(ialt))   * (1-factalt) 
+     &                      + log(ct1d(ialt+1)) * factalt    )
+           temp_c(l)  = t1d(ialt) * (1-factalt) + t1d(ialt+1) * factalt
+           print*,l,zalt,press_c(l),nb(l),temp_c(l)
+        enddo
         
 c caracteristiques des composes:        
 c -----------------------------
-        mass = 0.0
-        call comp(nomqy_c,mass)
+        mass(:) = 0.0
+        call comp(nomqy_c,nb,temp_c,mass,md)
         print*,'           Mass'
         do ic=1,NC
           print*,nomqy_c(ic),mass(ic)
+c         if(nomqy_c(ic).eq.'CH4') print*,"MD=",md(:,ic)
         enddo
 	
 
-c FLUX AU SOMMET: DEPENDANT DE LA LATITUDE ET DE LA SAISON... 
-
-c flux dans la derniere couche:(issu du modele 1D, a 500 km) 
-c -----------------------------
-c       !!  en cm-2.s-1 !!
-c  ces valeurs sont converties en cm-3.s-1 (dni/dt) dans a couche 54 
-c 
-c Lecture des tables de flux en fonction lat et saison
-c ----------------------------------------------------
-
-	WRITE(str2(1:2),'(i2.2)') ntotftop
-        formt1 = '(A10,'//str2//'(3X,A10))'
-        formt2 = '(F12.6,'//str2//'(2X,F13.6))'
-        formt3 = '(F13.6,'//str2//'(2X,F13.6))'
-	
-	do j=1,jjp1
-	  do ic=1,NC
-	    do l=1,5
-	     tablefluxtop(ic,j,l) = 0.
-	    enddo
-	  enddo
-	enddo
-	
-        do l=1,4
-	  WRITE(str1(1:1),'(i1.1)') l
-c hx1 -> Ls=RPI/2 / hx4 -> Ls=0
-          open(10,file="../../INPUT/FLUXTOP/flux500.hs"//str1)
-c         open(10,file="FLUXTOP/flux500.hs"//str1)
-c on remet l=1 et 5 -> Ls=0 / l=2 -> Ls=RPI/2 ...
-
-          read(10,formt1) nomsftop
-	  do j=1,ntotftop
-           do i=1,10   !justification a gauche...
-             if (nomsftop(j+1)(i:i).ne.' ') then
-                nomsftop(j) = nomsftop(j+1)(i:)
-                goto 100
-             endif
-           enddo
-100        continue
-c         print*,nomsftop(j)
-           nftop(j) = 0
-           do i=1,NC
-	    if (nomqy_c(i).eq.nomsftop(j)) then
-             nftop(j) = i
-	    endif
-	   enddo
-c          if (nftop(j).ne.0) print*,nomsftop(j),nomqy_c(nftop(j))
-	  enddo
-
-	 
-c lecture des flux. Les formats sont un peu alambiques... 
-c     a revoir eventuellement
-	  do j=1,jjp1/2+1
-	    read(10,formt2) latit,tabletmp
-	    do i=1,ntotftop
-              if (nftop(i).ne.0) then
-	       tablefluxtop(nftop(i),j,l+1) = tabletmp(i)
-              endif
-	    enddo
-	  enddo
-	  do j=jjp1/2+2,jjp1
-	    read(10,formt3) latit,tabletmp
-	    do i=1,ntotftop
-              if (nftop(i).ne.0) then
-	       tablefluxtop(nftop(i),j,l+1) = tabletmp(i)
-              endif
-	    enddo
-	  enddo
-
-          close(10)
-	enddo  ! l
-	
-	do j=1,jjp1
-	  do ic=1,NC
-	     tablefluxtop(ic,j,1) = tablefluxtop(ic,j,5)
-	  enddo
-	enddo
-	
-c  Stockage des composes utilises dans la prod d'aerosols
+c  Stockage des composes utilises dans la prod d aerosols
 c     (aerprod=1) et dans H-> H2 (htoh2=1): utilaer
 c     ! decalage de 1 car utilise dans le c !
-c ------------------------------------------
-c + modifs du flux en fonction des obs UVIS et CIRS: C2H2,C2H6,HCN
-c + modifs des flux qui presentent un probleme evident: C3H8 et C4H10
-c ------------------------------------------
 
         do ic=1,NC
@@ -244,9 +204,4 @@
 	  if (nomqy_c(ic).eq."HCN") then
             utilaer(6)  = ic-1
-	    do j=1,jjp1
-              do i=1,5
-             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * 6.
-              enddo
-            enddo
 	  endif
 	  if (nomqy_c(ic).eq."HC3N") then
@@ -268,10 +223,4 @@
 	  if (nomqy_c(ic).eq."C2H2") then
             utilaer(3)  = ic-1
-	    do j=1,jjp1
-              do i=1,5
-c             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * 7.3
-             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * 10.
-              enddo
-            enddo
 	  endif
 	  if (nomqy_c(ic).eq."AC6H6") then
@@ -298,28 +247,4 @@
 	  if (nomqy_c(ic).eq."AC6H5") then
             utilaer(12) = ic-1
-	  endif
-
-	  if (nomqy_c(ic).eq."C2H6") then
-	    do j=1,jjp1
-              do i=1,5
-c             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * 640.
-             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * 1200.
-              enddo
-            enddo
-	  endif
-	  if (nomqy_c(ic).eq."C3H8") then
-	    do j=1,jjp1
-              do i=1,5
-c             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * (-1.)
-             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * (-3000.)
-              enddo
-            enddo
-	  endif
-	  if (nomqy_c(ic).eq."C4H10") then
-	    do j=1,jjp1
-              do i=1,5
-             tablefluxtop(ic,j,i) = tablefluxtop(ic,j,i) * (-1.)
-              enddo
-            enddo
 	  endif
 
@@ -369,4 +294,29 @@
 c       enddo
 
+
+c   init kedd
+c   ---------
+c   kedd stays constant with time and space 
+c   => linked to pressure rather than altitude...
+ 
+      kedd(:) = 5e2 ! valeur mise par defaut  
+               ! UNITE ? doit etre ok pour gptitan
+      do l=1,NLEV
+       zalt=rmil(l)-RA/1000.  ! z en km
+       if     ((zalt.ge.250.).and.(zalt.le.400.)) then 
+         kedd(l) = 10.**(3.+(zalt-250.)/50.)
+! 1E3 at 250 km
+! 1E6 at 400 km
+       elseif ((zalt.gt.400.).and.(zalt.le.600.)) then 
+         kedd(l) = 10.**(6.+1.3*(zalt-400.)/200.)
+! 2E7 at 600 km
+       elseif ((zalt.gt.600.).and.(zalt.le.900.)) then 
+         kedd(l) = 10.**(7.3+0.7*(zalt-600.)/300.)
+! 1E8 above 900 km
+       elseif ( zalt.gt.900.                    ) then 
+        kedd(l) = 1.e8
+       endif
+      enddo
+
       ENDIF  ! premier appel
 
@@ -380,16 +330,4 @@
 c      print*,'declinaison en degre=',declin_c
        
-c-----------------------------------------------------------------------
-c
-c   calcul du facteur d'interpolation entre deux saisons pour flux
-c   --------------------------------------------------------------
-
-       isaisonflux = int(ls_rad*2./RPI)+1
-       if (isaisonflux.eq.5) then
-         isaisonflux = 1
-       endif
-       factflux =    (sin(ls_rad)-sin((isaisonflux-1)*RPI/2.))/
-     .   (sin(isaisonflux*RPI/2.)-sin((isaisonflux-1)*RPI/2.))
-
 c***********************************************************************
 c***********************************************************************
@@ -410,4 +348,23 @@
 c***********************************************************************
 
+c-----------------------------------------------------------------------
+c
+c   Distance radiale (intercouches, en km)
+c   ----------------------------------------
+
+       do l=1,klev
+         rinter(l) = (RA+czlev(j,l))/1000.
+         rmil(l)   = (RA+czlay(j,l))/1000.
+c        print*,rinter(l)
+       enddo
+
+c au-dessus du GCM, dr regulier et rinter(NLEV)=1290+2575 km.
+       do l=klev+1,NLEV
+         rinter(l) = rinter(klev)
+     &          + (l-klev)*(3865.-rinter(klev))/(NLEV-klev)
+         rmil(l)   = rmil(klev)
+     &          + (l-klev)*(3865.-rinter(klev))/(NLEV-klev)
+       enddo
+        
 c-----------------------------------------------------------------------
 c
@@ -423,51 +380,75 @@
                nb(l) = 1.e-4*press_c(l) / (RKBOL*temp_c(l))
        ENDDO
-       
-c-----------------------------------------------------------------------
-c
-c   Distances radiales (intercouches, en km)
-c   ----------------------------------------
-
-       rinter(1) = RA/1000.  
-       do l=2,klev
-c A REVOIR: g doit varier avec r !
-         rinter(l) = rinter(l-1) + 
-     .    (cplev(j,l-1)-cplev(j,l))/cplay(j,l)*(RD*temp_c(l)/RG)/1000.
-c        print*,rinter(l)
-       enddo
-
-c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-c FLUX AU TOP: interpolation en saison et
-c conversion en cm-3 s-1 dans la couche klev-1 (NLEV-2 dans le C) 
-c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        do ic=1,NC
-          fluxtop(ic) = tablefluxtop(ic,j,isaisonflux)  *(1-factflux)
-     .                + tablefluxtop(ic,j,isaisonflux+1)*  factflux
-          fluxtop(ic) = fluxtop(ic)/((rinter(klev)-rinter(klev-1))*1e5)
-        enddo
-
-c TEST: sortie de l'un des flux avec saveLs et factflux
-c       dans un fichier special pour tracer avec gnuplot
-c       if (j.eq.2) then
-c       open(unit=11,file="flux_80N.txt",status='old',position='append')
-c         write(11,*) ls_rad*180./RPI, factflux, 
-c    .           ((rinter(llm)-rinter(llm-1))*1e5), fluxtop
-c         write(11,*) ls_rad*180./RPI, factflux, 
-c    .     fluxtop(utilaer(3)+1)*((rinter(llm)-rinter(llm-1))*1e5),  !C2H2
-c    .     fluxtop(utilaer(6)+1)*((rinter(llm)-rinter(llm-1))*1e5)   !HCN
-c       close(11)
-c       endif
-c       if (j.eq.17) then
-c       open(unit=11,file="flux_eq.txt",status='old',position='append')
-c         write(11,*) ls_rad*180./RPI, factflux, 
-c    .           ((rinter(llm)-rinter(llm-1))*1e5), fluxtop
-c         write(11,*) ls_rad*180./RPI, factflux, 
-c    .     fluxtop(utilaer(3)+1)*((rinter(llm)-rinter(llm-1))*1e5),  !C2H2
-c    .     fluxtop(utilaer(6)+1)*((rinter(llm)-rinter(llm-1))*1e5)   !HCN
-c       close(11)
-c       endif
-c FIN TEST: sortie de l'un des flux avec ls et factflux
-
-c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+c extension pour klev+1 a NLEV avec tcp.ver
+       ialt=1
+       do l=klev+1,NLEV
+           zalt=rmil(l)-RA/1000.
+           do i=ialt,130
+            if ((zalt.ge.r1d(i)).and.(zalt.lt.r1d(i+1))) then
+              ialt=i
+            endif
+           enddo
+           factalt = (zalt-r1d(ialt))/(r1d(ialt+1)-r1d(ialt))
+           press_c(l) = exp(  log(p1d(ialt))   * (1-factalt) 
+     &                      + log(p1d(ialt+1)) * factalt    )
+           nb(l)      = exp(  log(ct1d(ialt))   * (1-factalt) 
+     &                      + log(ct1d(ialt+1)) * factalt    )
+           temp_c(l)  = t1d(ialt) * (1-factalt) + t1d(ialt+1) * factalt
+       enddo
+               
+c-----------------------------------------------------------------------
+c
+c   passage krpd => krate 
+c   ---------------------
+c initialisation krate pour dissociations 
+
+      if ((declin_c*10+267).lt.14.) then
+          declinint = 0
+          dec       = 0
+      else 
+       if ((declin_c*10+267).gt.520.) then
+          declinint = 14
+          dec       = 534
+       else 
+          declinint = 1
+          dec       = 27
+          do while( (declin_c*10+267).ge.real(dec+20) )
+            dec       = dec+40
+            declinint = declinint+1
+          enddo
+       endif
+      endif
+      if ((declin_c.ge.-24.).and.(declin_c.le.24.)) then
+          factdec = ( declin_c - (dec-267)/10. ) / 4.
+      else
+          factdec = ( declin_c - (dec-267)/10. ) / 2.7
+      endif
+
+      do l=1,NLEV
+
+c INTERPOL EN ALT POUR k (krpd tous les deux km)
+        ialt    = int((rmil(l)-RA/1000.)/2.)+1
+        factalt = (rmil(l)-RA/1000.)/2.-(ialt-1)
+
+        do i=1,ND+1
+          krpddecm1 = krpd(declinint  ,i,ialt  ,klat(j)) * (1-factalt)
+     &              + krpd(declinint  ,i,ialt+1,klat(j)) * factalt
+          krpddec   = krpd(declinint+1,i,ialt  ,klat(j)) * (1-factalt)
+     &              + krpd(declinint+1,i,ialt+1,klat(j)) * factalt
+          krpddecp1 = krpd(declinint+2,i,ialt  ,klat(j)) * (1-factalt)
+     &              + krpd(declinint+2,i,ialt+1,klat(j)) * factalt
+
+                    ! ND+1 correspond a la dissociation de N2 par les GCR
+          if ( factdec.lt.0. ) then 
+        krate(l,i) = krpddecm1 * abs(factdec)
+     &             + krpddec   * ( 1 + factdec)
+          endif
+          if ( factdec.gt.0. ) then
+        krate(l,i) = krpddecp1 * factdec
+     &             + krpddec   * ( 1 - factdec)
+          endif
+          if ( factdec.eq.0. ) krate(l,i) = krpddec
+        enddo        
+      enddo        
 
 c-----------------------------------------------------------------------
@@ -475,11 +456,52 @@
 c   composition 
 c   ------------
-       
+
        do ic=1,NC
         do l=1,klev
-          cqy(l,ic) = qy_c(j,l,ic) 
-        enddo
-       enddo
-              
+          cqy(l,ic)  = qy_c(j,l,ic) 
+          cqy0(l,ic) = cqy(l,ic)
+        enddo
+       enddo
+
+c lecture du fichier compo_klat(j) (01 à 49) pour klev+1 a NLEV
+
+      WRITE(str2,'(i2.2)') klat(j)
+      fich = "comp_"//str2//".dat"
+      inquire (file=fich,exist=okfic)
+      if (okfic) then
+       open(11,file=fich,status='old')
+c premiere ligne=declin
+       read(11,'(A15)') ficdec
+       write(curdec,'(E15.5)') declin_c
+c si la declin est la meme: ce fichier a deja ete reecrit 
+c on lit la colonne t-1 au lieu de la colonne t
+c (cas d une bande de latitude partagee par 2 procs)
+       do ic=1,NC
+        read(11,'(A10)') name
+        if (name.ne.nomqy_c(ic)) then
+          print*,"probleme lecture ",fich
+          print*,name,nomqy_c(ic)
+          stop
+        endif
+        if (ficdec.eq.curdec) then
+          do l=klev+1,NLEV
+            read(11,*) ficalt,cqy(l,ic),newq
+          enddo
+        else
+          do l=klev+1,NLEV
+            read(11,*) ficalt,oldq,cqy(l,ic)
+          enddo
+        endif
+       enddo
+       close(11)
+      else       ! le fichier n'est pas la
+       do ic=1,NC
+        do l=klev+1,NLEV
+          cqy(l,ic)=cqy(klev,ic)
+        enddo
+       enddo
+      endif
+      cqy0 = cqy
+
 c-----------------------------------------------------------------------
 c
@@ -502,7 +524,7 @@
        
        call gptitan(rinter,temp_c,nb,
-     $              nomqy_c,cqy,fluxtop,
-     $              declin_c,duree,(klat(j)-1),mass,
-     $              botCH4,krpd,krate,reactif,
+     $              nomqy_c,cqy,
+     $              duree,(klat(j)-1),mass,md,
+     $              kedd,botCH4,krate,reactif,
      $              nom_prod,nom_perte,prod,perte,
      $              aerprod,utilaer,cmaer,cprodaer,ccsn,ccsh,
@@ -514,5 +536,5 @@
        do ic=1,NC
         do l=1,klev
-          dqyc(j,l,ic) = (cqy(l,ic) - qy_c(j,l,ic))/dtchim  ! en /s
+          dqyc(j,l,ic) = (cqy(l,ic) - cqy0(l,ic))/dtchim  ! en /s
         enddo
        enddo
@@ -535,4 +557,23 @@
 
        endif
+
+c-----------------------------------------------------------------------
+c
+c   sauvegarde compo sur NLEV 
+c   -------------------------
+
+c dans fichier compo_klat(j) (01 à 49)
+       
+      open(11,file=fich,status='replace')
+c premiere ligne=declin
+      write(11,'(E15.5)') declin_c
+      do ic=1,NC
+       write(11,'(A10)') nomqy_c(ic)
+       do l=klev+1,NLEV
+        write(11,'(E15.5,1X,E15.5,1X,E15.5)') rmil(l)-RA/1000.,
+     .                                cqy0(l,ic),cqy(l,ic)
+       enddo
+      enddo
+      close(11)
 
 c***********************************************************************
